macroScript cameraShake
category:".elfin"
icon:#("CamP",1)
tooltip:"Camera Shake"
buttontext:"Camera Shake"

(
	global cameraShakeDialog
	local edit_cam = false
	
	fn camera_shake =
	(
		clearListener()
		
		for i in selection do
		(
			if superClassOf i == camera then
			(
				if edit_cam == false then
				(
					obj = Point isSelected:on
					obj.name = "Helper_" + i.name
					obj.constantscreensize = on
					obj.position = i.position
					i.parent = obj
				) else obj = i
				obj.showTrajectory = on
				
				
				obj.pos.controller = Position_List()
				obj.pos.controller.Available.controller = Position_XYZ()
				obj.pos.controller.setname 2 "Camera Shake"
				
				obj.pos.controller[2].controller = Noise_position()
				obj.pos.controller[2].controller.frequency = 0.005
				obj.pos.controller[2].controller.noise_strength = [20,20,20]
				
				
				if classOf i == Freecamera or (classOf i == VRayPhysicalCamera and i.targeted == false) then
				(
					obj.rotation.controller = Rotation_List()
					obj.rotation.Available.controller = Euler_XYZ()
					obj.rotation.controller.setname 2 "Camera Shake"
					
					obj.rotation.controller[2].controller = Noise_rotation()
					obj.rotation.controller[2].controller.frequency = 0.008
					obj.rotation.controller[2].controller.noise_strength = [0.0349,0.0349,0.0349]
				)
				
				
				shakeAttributes = attributes "Camera Shake"
				(
					parameters main rollout:params
					(
						pos_frequency type:#float ui:pos_frequency default:0.005
						pos_strength type:#float ui:pos_strength default:20
						rot_frequency type:#float ui:rot_frequency default:0.008
						rot_strength type:#float ui:rot_strength default:0.0349
						multiplier type:#float ui:multiplier default:1
					)
					
					rollout params "Shake Parameters"
					(
						groupBox pos_grp "Position:" pos:[8,2] width:147 height:62
						spinner pos_frequency "Frequency:" type:#float scale:0.001 offset:[-3,-50] range:[0,1,0.005]
						spinner pos_strength "Noise:" type:#float offset:[-3,0] range:[0,100,20]
						
						groupBox rot_grp "Rotation:" width:147 height:62 offset:[-5,10]
						spinner rot_frequency "Frequency:" type:#float offset:[-3,-50] range:[0,1,0.008]
						spinner rot_strength "Noise:" type:#float scale:0.001 offset:[-3,0] range:[0,1,0.0349]
						
						spinner multiplier "Multiplier" type:#float offset:[-3,15] range:[0,1,1]
						
						on params open do
						(
							pos_frequency.value = $.pos.controller[2].controller.frequency
							pos_strength.value = $.pos.controller[2].controller.noise_strength[1]
							
							try
							(
								rot_frequency.value = $.rotation.controller[2].controller.frequency
								rot_strength.value = $.rotation.controller[2].controller.noise_strength
							) catch()
							
							multiplier.value = $.pos.controller.weight[2]/100
						)
						
						on pos_frequency changed val do $.pos.controller[2].controller.frequency = val
						on pos_strength changed val do $.pos.controller[2].controller.noise_strength = [val,val,val]
						
						on rot_frequency changed val do try $.rotation.controller[2].controller.frequency = val catch()
						on rot_strength changed val do try $.rotation.controller[2].controller.noise_strength = [val,val,val] catch()
						
						on multiplier changed val do
						(
							$.pos.controller.weight[2] = val*100
							try $.rotation.controller.weight[2] = val*100 catch()
						)
					)
				)
				custAttributes.add obj shakeAttributes
			)
		)
	)
	
	try destroyDialog cameraShakeDialog catch()
	
	rollout cameraShakeDialog "Camera Shake" width:176 height:112
	(
		listBox lbx "Add Shake To:" pos:[8,8] width:160 height:3 items:#("Camera","Helper")
		button btn_ok "OK" pos:[8,80] width:80 height:24
		button btn_cancel "Cancel" pos:[88,80] width:80 height:24
		
		on btn_ok pressed do
		(
			if lbx.selection == 1 then edit_cam = true
			camera_shake()
			destroyDialog cameraShakeDialog
		)
		on btn_cancel pressed do
		(
			destroyDialog cameraShakeDialog
		)
	)
	
	createDialog cameraShakeDialog style:#(#style_toolwindow, #style_sysmenu)
)